#include "RTreeOct.h"

octave_value RTreeOct::bsrt_read(octave_value fd_ov)
{
  int fd = fd_ov.int_value();
  RTreeOct *rto = new RTreeOct(RTreeC::bsrt_read(fd));
  return octave_value(rto);
}

octave_value RTreeOct::constructor(octave_value dim_ov,
                                   octave_value split_ov,
                                   octave_value node_page_ov)
{
  std::size_t dim = dim_ov.int_value();
  std::string split = split_ov.string_value();
  std::uint32_t node_page = node_page_ov.int_value();

  RTreeOct *rto = new RTreeOct(dim, split, node_page);
  return octave_value(rto);
}

octave_value RTreeOct::csv_read(octave_value fd_ov,
                                octave_value dim_ov,
                                octave_value split_ov,
                                octave_value node_page_ov)
{
  int fd = fd_ov.int_value();
  std::size_t dim = dim_ov.int_value();
  std::string split = split_ov.string_value();
  std::uint32_t node_page = node_page_ov.int_value();

  RTreeOct *rto = new RTreeOct(RTreeC::csv_read(fd, dim, split, node_page));
  return octave_value(rto);
}

octave_value RTreeOct::json_read(octave_value fd_ov)
{
  int fd = fd_ov.int_value();
  RTreeOct *rto = new RTreeOct(RTreeC::json_read(fd));
  return octave_value(rto);
}

DEFINE_OV_TYPEID_FUNCTIONS_AND_DATA(RTreeOct, "RTree wrapper", "RTreeOct");
