#include <octave/oct.h>

#include "RTreeStyleC.h"

#include <unistd.h>

RTreeStyleC::RTreeStyleC()
{
  error_with_id("RTreeStyle:BUG", "default constructor called");
}

RTreeStyleC::RTreeStyleC(postscript_style_t *style)
{
  this->style = style;
}

RTreeStyleC::~RTreeStyleC(void)
{
  postscript_style_destroy(this->style);
}

RTreeStyleC* RTreeStyleC::json_read(int fd)
{
  int fd2;

  if ((fd2 = dup(fd)) == -1)
    error_with_id("RTreeStyle:ERRNO",
                  "dup: %s", strerror(errno));

  FILE *st;

  if ((st = fdopen(fd2, "r")) == NULL)
    error_with_id("RTreeStyle:ERRNO",
                  "fdopen: %s", strerror(errno));

  errno = 0;

  postscript_style_t *style = postscript_style_read(st);

  fclose(st);

  if (style == NULL)
    {
      if (errno)
        error_with_id("RTreeStyle:ERRNO", "%s", strerror(errno));
      else
        error_with_id("RTreeStyle:librtree", "parse of JSON");
    }

  return new RTreeStyleC(style);
}
